
#include <glade/glade.h>
#include <glade/glade-xml.h>
#include <assert.h>

#ifndef SCM_MAJOR_VERSION /* then it's guile 1.4 or earlier */
# define GUILE14 1
#endif

#include <libguile.h>
#include <guile/gh.h>
#include <guile-gtk.h>
typedef SCM (*scmf)();

#ifdef GUILE14
# define scm_c_define_gsubr scm_make_gsubr
# define SCM_STRING_CHARS SCM_CHARS
#endif


static SCM s_glade_init ()
{
  glade_init ();
  return SCM_BOOL_T;
}


static SCM s_glade_xml_new (SCM s_fname)
{
  GladeXML *gxml;
  char *fname;
  SCM_DEFER_INTS;
  fname = SCM_STRING_CHARS (s_fname);
  gxml = glade_xml_new (fname, NULL);
  SCM_ALLOW_INTS;
  return sgtk_wrap_gtkobj ((GtkObject*) gxml);
}


static SCM s_glade_xml_get_widget (SCM s_self, SCM s_name)
{
  GtkWidget *w;
  char *name;
  GladeXML *self;
  SCM_DEFER_INTS;
  self = (GladeXML *) sgtk_get_gtkobj (s_self);
  name = SCM_STRING_CHARS (s_name);
  w = glade_xml_get_widget (self, name);
  SCM_ALLOW_INTS;
  return sgtk_wrap_gtkobj ((GtkObject *) w);
}


void init_glade_defs ()
{
  scm_c_define_gsubr ("glade-init", 0, 0, 0,
		      (scmf) s_glade_init);
  scm_c_define_gsubr ("glade-xml-new", 1, 0, 0,
		      (scmf) s_glade_xml_new);
  scm_c_define_gsubr ("glade-xml-get-widget", 2, 0, 0,
		      (scmf) s_glade_xml_get_widget);

}
